package edu.usc.ict.iago.views;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;

import edu.usc.ict.iago.utils.GameSpec;
import edu.usc.ict.iago.utils.Offer;

class ResourceGameSpec implements GameSpec{
	
	
	@SuppressWarnings("unused")
	private static final HashMap<LinkedList<Integer>, Integer> advancedVHPoints = new HashMap<LinkedList<Integer>, Integer>();
	@SuppressWarnings("unused")
	private static final HashMap<LinkedList<Integer>, Integer> advancedPlayerPoints = new HashMap<LinkedList<Integer>, Integer>();
	private static final HashMap<String, Integer> simpleVHPoints = new HashMap<String, Integer>();
	private static final HashMap<String, Integer> simplePlayerPoints = new HashMap<String, Integer>();
	
	private static final Map<String, Map<String, String>> menuIndex= new HashMap<String, Map<String, String>>();
	private static final HashMap<String, String> menuRoot= new HashMap<String, String>();
	private static final HashMap<String, String> menuYouLike= new HashMap<String, String>();
	private static final HashMap<String, String> menuILike= new HashMap<String, String>();
	private static final HashMap<String, String> menuBecause= new HashMap<String, String>();
	
	private static final boolean isBlind = true; //whether the player score is visible to the agent
	private static final boolean isVHScoreVisible = false;
	private boolean isPrivileged;
	
	//private LinkedList<Event> eventQ = new LinkedList<Event>();

	ResourceGameSpec(boolean privileged) 
	{
		isPrivileged = privileged;
		//VH preferences
		simpleVHPoints.put(getIssuePluralNames()[0], 4);
		simpleVHPoints.put(getIssuePluralNames()[1], 3);
		simpleVHPoints.put(getIssuePluralNames()[2], 2);
		simpleVHPoints.put(getIssuePluralNames()[3], 1);
		
		simplePlayerPoints.put(getIssuePluralNames()[0], 1);
		simplePlayerPoints.put(getIssuePluralNames()[1], 2);
		simplePlayerPoints.put(getIssuePluralNames()[2], 3);
		simplePlayerPoints.put(getIssuePluralNames()[3], 4);
		
		menuRoot.put("butYouLike", "Ask him his preferences >");
		menuRoot.put("butILike", "Tell him your preferences >");
		menuRoot.put("butBecause", "Justify your actions >");
		
		
		menuYouLike.put("craftingMessageString", "");
		menuYouLike.put("butItemsDiv", "");
		for (int i = 0; i < getNumIssues(); i++)
			menuYouLike.put("butItem" + i, "");
		menuYouLike.put("butItemsComparison", "");
		menuYouLike.put("butItemFirst","");
		menuYouLike.put("butItemComparison","");
		menuYouLike.put("butItemSecond","");
		
		menuYouLike.put("butConfirm", "<Confirm>");
		menuYouLike.put("butBack", "<Back>");	
		menuILike.put("craftingMessageString", "");
		menuILike.put("butItemsDiv", "");
		for (int i = 0; i < getNumIssues(); i++)
			menuILike.put("butItem" + i, "");
		menuILike.put("butItemsComparison", "");
		menuILike.put("butItemFirst","");
		menuILike.put("butItemComparison","");
		menuILike.put("butItemSecond","");
		menuILike.put("butConfirm", "<Confirm>");
		menuILike.put("butBack", "<Back>");
		
		menuBecause.put("messageBuffer", "");
		menuBecause.put("butExpl0",  "It is important that we are both happy with an agreement.");
		menuBecause.put("butExpl1",  "I gave a little here; you give a little next time.");
		menuBecause.put("butExpl2",  "We should try to split things evenly.");
		menuBecause.put("butExpl3",  "We should each get our most valuable item.");
		menuBecause.put("butExpl4",  "Accept this or there will be consequences.");
		menuBecause.put("butExpl5",  "This is the last offer.  Take it or leave it.");
		menuBecause.put("butExpl6",  "This is the very best offer possible.");
		menuBecause.put("butExpl7",  "Your offer sucks.");
		menuBecause.put("butExpl8",  "I can't go any lower than this.");
		menuBecause.put("butExpl9",  "We should try harder to find a deal that benefits us both.");
		menuBecause.put("butExpl10", "There's hardly any time left to negotiate!");
		menuBecause.put("butExpl11", "Why don't you make an offer?");
		menuBecause.put("butBack", "<Back>");
		
		menuIndex.put("root", menuRoot);
		menuIndex.put("youLike", menuYouLike);
		menuIndex.put("iLike", menuILike);
		menuIndex.put("because", menuBecause);
	}

	@Override
	public int getNumIssues() {
		return 4;
	}

	@Override
	public int[] getIssueQuants() {
		return new int[] {5,5,5,5};
	}

	@Override
	public String[] getIssuePluralNames() {
		return new String[] {"bars of iron", "bars of gold", "shipments of bananas", "shipments of spices"};
	}

	@Override
	public String[] getIssueNames() {
		return new String[] {"bar of iron", "bar of gold", "shipment of bananas", "shipment of spice"};
	}

	@Override
	public Map<Offer, Integer> getAdvancedVHPoints() {
		return null;
	}

	@Override
	public Map<Offer, Integer> getAdvancedPlayerPoints() throws SecurityException{
		return null;
	}

	@Override
	public Map<String, Integer> getSimpleVHPoints() {
		return simpleVHPoints;
	}

	@Override
	public Map<String, Integer> getSimplePlayerPoints() throws SecurityException
	{
		if (!isBlind)
			return simplePlayerPoints;
		else
		{
			if(isPrivileged)
				return simplePlayerPoints;
			else
				throw new SecurityException("Agent is attempting to access privileged information.");
		}
	}

	@Override
	public boolean isAdvancedPoints() {
		return false;
	}
	

	@Override
	public Map<String, Map<String, String>> getMenu() {
		return menuIndex;
	}

	@Override
	public int getTotalTime() {
		return 600;
	}
	
	@Override
	public boolean isPlayerBlind() {
		return isBlind;
	}

	@Override
	public int getVHBATNA() {
		return 4;
	}

	@Override
	public int getPlayerBATNA() throws SecurityException {
		if (!isBlind)
			return 4;
		else
		{
			if(isPrivileged)
				return 4;
			else
				throw new SecurityException("Agent is attempting to access privileged information.");
		}
	}

	@Override
	public boolean showAgentScore() {
		return isVHScoreVisible;
	}
	
	@Override
	public String getTargetEmail()
	{
		return "yourDataEmailHere@university.edu";
	}

	@Override
	public String getEndgameMessage() {
		return "<p>Thank you for participating.  You may enter the following code on MTurk to receive credit for your work: \"SAMPLE CODE\"</p>";
	}

	@Override
	public boolean showOpponentScoreOnEnd() {
		return true;
	}

	@Override
	public boolean showNegotiationTimer() {
		return true;
	}

	@Override
	public int getOverflowSize() {
		return 10;
	}

}
